/***************************************************************************
                          kap_ippselector.cpp  -  description
                             -------------------
    begin                : Fri Mar 10 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kap_ippselector.h"
#include "kap_ipputil.h"
#include "kprinterdescription.h"
#include "kups.h"

#include <kapp.h>

Kap_IppSelector::Kap_IppSelector(QWidget *parent, const char *name )
:Kap_MoreInfoPage(parent,name)
{
	setTitle(i18n("IPP server informations"));
	
	setNumberOfInfos(2);
	setLabel(0,i18n("Host"));
	setLabel(1,i18n("Port"));

	setText(0,"localhost");
	setText(1,"631");
}

Kap_IppSelector::~Kap_IppSelector()
{
}

Kap_Main::e_PageType Kap_IppSelector::getType() const
{
	return Kap_Main::IppSelector;
}

bool Kap_IppSelector::canNextPage(QString& msg)
{
	bool	ok;
	int	p(631);
	QString	host(text(0)), port(text(1));
	if (host.isEmpty())
	{
		msg = i18n("You must specify a host !");
		return false;
	}
	if (!port.isEmpty())
	{
		p = port.toInt(&ok);
		if (!ok)
		{
			msg = i18n("Wrong port number !");
			return false;
		}
	}
	if (!Kap_IppUtil::hasCupsServer(host,p))
	{
		msg = i18n("No CUPS server running on this host !");
		return false;
	}
	return true;
}

Kap_Main::e_PageType Kap_IppSelector::getNextPage(QString&, bool fake)
{
	if (fake) return Kap_Main::IppPrinterSelector;

	KPrinterDescription	*descr = KPrinterDescription::get();
	QString	host(text(0)), port(text(1));
	int	p = port.toInt();
	descr->setSocketInfo(host,p);
	return Kap_Main::IppPrinterSelector;
}
