/***************************************************************************
                          kap_lastconfirmationpage.cpp  -  description
                             -------------------
    begin                : Tue Feb 1 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <qlayout.h>
#include <qtextview.h>
#include <qpushbutton.h>
#include <qstylesheet.h>


#include <qmessagebox.h>
#include <kapp.h>


#include "kups.h"
#include "kbuffer.h"

#include "kap_lastconfirmationpage.h"
#include "kap_backendselector.h"
#include "kap_namelocationselectorpage.h"
//#include "kap_manumodeldico.h"

#include "kprintermanager.h"
#include "kprinterdescription.h"



Kap_LastConfirmationPage::Kap_LastConfirmationPage(QWidget *parent, const char *name )
:Kap_WizardPage(parent,name)
{
	setTitle(i18n("Confirmation"));
	
	label_ = new QTextView(this);
	label_->setText("To BE SET");
	label_->setStyleSheet( QStyleSheet::defaultSheet() );
//	label_->setReadOnly(true);

	layout_ = new QVBoxLayout(this,5);
	layout_->addWidget(label_);
	
	layout_->activate();
}
Kap_LastConfirmationPage::~Kap_LastConfirmationPage()
{
}

bool Kap_LastConfirmationPage::hasPrevPage()
{
	return true;
}
bool Kap_LastConfirmationPage::hasNextPage()
{
	return false;
}

bool Kap_LastConfirmationPage::canNextPage(QString&)
{
	return true;
}

bool Kap_LastConfirmationPage::slotOk()
{
	QString str;
	KPrinterDescription* descr = KPrinterDescription::get();
	bool	value(false);
	ASSERT(descr);

	if (KPrinterManager::get()->addPrinter(*descr)) value = true;
	else
	{
		str.sprintf(i18n("Add printer failed with error message:\n%s"), KPrinterManager::getLastError().data() );
		QMessageBox::critical(this, i18n("Add printer"), str, QMessageBox::Ok|QMessageBox::Default,0);
		value = false;
	}
	
	KPrinterDescription::release();
	return value;
}
bool Kap_LastConfirmationPage::hasOkButton()
{
	return true;
}
bool Kap_LastConfirmationPage::hasCancelButton()
{
	return true;
}

bool Kap_LastConfirmationPage::initialize()
{
	KPrinterDescription* descr = KPrinterDescription::get();
		
 	QString str;
	str = descr->getDescriptionString();
//	str += "\n\n\tAre you sure?";
	label_->setText(str);
		
	return true;
}

Kap_Main::e_PageType Kap_LastConfirmationPage::getType() const
{
	return Kap_Main::Confirmation;
}
