/***************************************************************************
                          kap_manumodeldico.h  -  description
                             -------------------
    begin                : Sun Feb 13 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KAP_MANUMODELDICO_H
#define KAP_MANUMODELDICO_H


#include <qlist.h>
#include <qdict.h>
#include <qobject.h>


#include <qstring.h>
#include <qstrlist.h>





/**
  *@author jec
  */





QString cleanModel(const QString& model, const QString& manu);

class KSimpleConfig;
class KBuffer;
class KProcess;

class Kap_ModelItem
{
public:
	Kap_ModelItem();
	virtual ~Kap_ModelItem();

	const QString& getManufacturer() const;
	void setManufacturer(const QString& );

	const QString& getModel() const;
	void setModel(const QString& str);

	const QString& getNickName() const;
	void setNickName(const QString& str);

	const QString& getShortNickName() const;
	void setShortNickName(const QString& str);

	const QString& getPpdFile() const;
	void setPpdFile(const QString& str);

	const QString& getPnpManufacturer() const;
	void setPnpManufacturer(const QString& str);

	const QString& getPnpModel() const;
	void setPnpModel(const QString& str);

	const QString& getPnpCmd() const;
	void setPnpCmd(const QString& str);

	const QString& getPnpDescr() const;
	void setPnpDescr(const QString& str);

	const QString& getStatus() const;
	void setStatus(const QString& str);

private:
	QString status_;

	QString manufacturer_;
	QString model_;
	QString nickName_;
	QString shortNickName_;
	QString ppdFile_;

	QString pnpManufacturer_;
	QString pnpModel_;
	QString pnpCmd_;
	QString pnpDescr_;

	void cleanUp();
};


typedef QList<Kap_ModelItem> Kap_ModelItemList;



class Kap_ManuModelDico : public QObject
{
public:
	Kap_ManuModelDico();
	~Kap_ManuModelDico();
	
	static Kap_ManuModelDico* get(bool check = false);
	
	Kap_ModelItemList* getDescription(const QString& manu, const QString& model);
	Kap_ModelItemList* getDescriptionForPnp(const QString& manu, const QString& model);
	
	QStrList& getManuList();
	QDict<Kap_ModelItemList>* getModelList(const QString& manu);
	
	KBuffer* getValidPpdFileAsBuffer(const Kap_ModelItem& item, KBuffer& buffer);

	bool checkDatabase(bool firstTime = false);
	
protected:
	bool initialize();
	bool makePrintersDb(const QString& ppdDirName, const QString& dbFilename, bool showDlg);
	
	bool addNewItem(Kap_ModelItem* item);

	bool splitString(const QString& line, QString& descr, QString& value);

	bool loadDatabase(const QString& dbFilename);

private:
	static Kap_ManuModelDico* unique_;
	
	QStrList manuList_;
	QDict< QDict<Kap_ModelItemList> >	manuDico_, pnpManuDico_;
	QString	errorString_;
};

#endif
