/***************************************************************************
                          kap_modelselectorpage.h  -  description
                             -------------------
    begin                : Thu Feb 3 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KAP_MODELSELECTORPAGE_H
#define KAP_MODELSELECTORPAGE_H


#include <qwidget.h>
#include <qstrlist.h>

#include <kap_wizardpage.h>

/**
  *@author jec
  */


class QLabel;
class QGroupBox;
class QListBox;
class QPushButton;
class QCheckBox;

class Kap_ModelSelectorPage : public Kap_WizardPage
{
   Q_OBJECT
public:
	Kap_ModelSelectorPage(QWidget *parent=0, const char *name=0);
	~Kap_ModelSelectorPage();

	virtual bool initialize();

	virtual Kap_Main::e_PageType getNextPage(QString& message, bool fake = false);
	virtual Kap_Main::e_PageType getType() const;
	
	virtual bool canNextPage(QString& msg);
	
protected slots:
	void slotManuChanged(int index);
	void slotModelChanged(int index);
	void slotBrowseClicked();
	void slotRaw(bool);
	void slotGenericPS(bool);

private:
	QString manu_;
	QString model_;

	QStrList manuList_;

	QGroupBox* groupBox_;

	QLabel* explLabel_;
	QListBox* manuBox_;
	QListBox* modelBox_;
	QPushButton* browsePpd_;

	QCheckBox*	raw_;
	QCheckBox*	genericps_;

	QString driver_;
        QString	nickname_;
};

#endif
