#include "kap_printergroup.h"
#include "kap_printeroption.h"

#define	INTER_WIDGET	10

Kap_PrinterGroup::Kap_PrinterGroup(ppd_group_t *group, QWidget *parent)
	: QWidget(parent)
{
	options_.setAutoDelete(false);
	subgroups_.setAutoDelete(false);
	size_ = QSize(0,0);
	if (group) init(group);
}

Kap_PrinterGroup::~Kap_PrinterGroup()
{
}

void Kap_PrinterGroup::init(ppd_group_t *group)
{
	if (group == 0) return;
	group_ = group;
	// parse options
	for (int i=0;i<group_->num_options;i++)
	{
		ppd_option_t	*option = group_->options+i;
		if (strcmp(option->keyword,"PageRegion") == 0) continue;
		Kap_PrinterOption	*po = new Kap_PrinterOption(option,this);
		options_.append(po);
		QSize	s(po->sizeHint());
		size_ = QSize(QMAX(size_.width(),s.width()),size_.height()+s.height()+INTER_WIDGET);
	}
	// parse subgroups
/*	for (int i=0;i<group_->num_subgroups;i++)
	{
		ppd_group_t	*subgroup = group_->subgroups+i;
		Kap_PrinterGroup	*sg = new Kap_PrinterGroup(subgroup,parentWidget());
	}*/
}

void Kap_PrinterGroup::resizeEvent(QResizeEvent *)
{
	int	h(10);
	QSize	s;
	QListIterator<Kap_PrinterOption>	it(options_);
	for (;it.current();++it)
	{
		s = it.current()->sizeHint();
		it.current()->setGeometry(10,h,width()-20,s.height());
		h += (s.height()+INTER_WIDGET);
	}
}

QSize Kap_PrinterGroup::sizeHint()
{
	return (size_+QSize(20,20));
}
