/***************************************************************************
                          kbuffer.h  -  description
                             -------------------
    begin                : Tue Jan 25 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBUFFER_H
#define KBUFFER_H



#include <qstring.h>


/**
  *@author jec
  */



class QString;

class KBuffer
{
public: 
	KBuffer();
	KBuffer(const QString& filename);
	KBuffer(const KBuffer& other);
	~KBuffer();

	void reset();
	const char* next(int atOneTime, int& bytes) const;
	int size() const;
	
	const char* data() const;
	
	bool load(const QString& filename);
	bool dump(const QString& filename) const;
	
	bool assign(const QString& str);
	bool append(const QString& str);

	bool assign(const KBuffer& buf);
	bool append(const KBuffer& buf);
	
	bool assign(const char* buf, int len);
	bool append(const char* buf, int len);
	
	bool replace(const QString& src, const QString& dest);
	
private:
	QByteArray buffer_;
	int pos_;
};

#endif
