/***************************************************************************
                          kups_ipprequest.h  -  description
                             -------------------
    begin                : Sun Nov 28 1999
    copyright            : (C) 1999 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KUPS_IPPREQUEST_H
#define KUPS_IPPREQUEST_H


#include <cups/cups.h>

/**
  *@author jec
  */


class Kups_AttributesIterator;
class KBuffer;


class Kups_IppRequest
{
public: 
	Kups_IppRequest();
	~Kups_IppRequest();
	
	Kups_AttributesIterator* getAttributesIterator();
	ipp_attribute_t* findAttribute(const QString& attrName, ipp_tag_t type);
		
	void setOperation(ipp_op_t op);

	void setUri(const QString& uriType, const QString& uri);
	void setUris(const QString& uriType, const QStringList& uris);
	//void setUriAt(const QString& uriType, int index, const QString& uri);
	void setInteger(const QString& uriType, int value);
	void setBoolean(const QString& uriType, bool value);
	void setMime(const QString& uriType, const QString& mime);
	void setName(const QString& uriType, const QString& name);
	void setNames(const QString& uriType, const QStringList& uris);
	void setText(const QString& uriType, const QString& name);

	void setUri(ipp_tag_t type, const QString& uriType, const QString& uri);
	void setUris(ipp_tag_t type, const QString& uriType, const QStringList& uris);
	//void setUriAt(ipp_tag_t type, const QString& uriType, int index, const QString& uri);
	void setInteger(ipp_tag_t type, const QString& uriType, int value);
	void setBoolean(ipp_tag_t type, const QString& uriType, bool value);
	void setMime(ipp_tag_t type, const QString& uriType, const QString& mime);
	void setName(ipp_tag_t type, const QString& uriType, const QString& name);
	void setNames(ipp_tag_t type, const QString& uriType, const QStringList& uris);
	void setText(ipp_tag_t type, const QString& uriType, const QString& name);
	
	bool doRequest(const QString& res);
	bool doBufferRequest(const QString& res, const KBuffer* buffer);
	bool doFileRequest(const QString& res, const QString& fileName);
	bool doStringRequest(const QString& res, const QString& strToSend);
	
	ipp_status_t getResponseStatus();
	
	bool myCupsDoFileRequest(http_t*  http,	/* I - HTTP connection to server */
                  ipp_t*     request,	/* I - IPP request */
                  ipp_t*&    response,
                  const QString& resource,	/* I - HTTP resource for POST */
									const KBuffer* buf,
									QString& last_error);
									
private:
	http_t* http_;
	
	ipp_t* request_;
	ipp_t* response_;
	
	Kups_AttributesIterator* attributesIterator_;
};

#endif











