/***************************************************************************
                          kups_optionsdialog.cpp  -  description
                             -------------------
    begin                : Sun Feb 13 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include <qgroupbox.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qslider.h>
#include <qpushbutton.h>
#include <qfileinfo.h>
#include <qlcdnumber.h>


#include <kfiledialog.h>


#include "kups_optionsdialog.h"
#include <qstring.h>
#include "kups_infos.h"



Kups_OptionsDialog::Kups_OptionsDialog(QWidget *parent, const char *name )
:QDialog(parent, "Options", true)
{
	//user, password, server, port, refTime, altTestPage
	userGroupBox_ = new QGroupBox(this);
	userGroupBox_->setTitle("CUPS server");
	userGroupBox_->setMaximumSize(32767, 32767);
	QVBoxLayout	*mainLayout_ = new QVBoxLayout(this, 5, 5);
	mainLayout_->addWidget(userGroupBox_);
	
	QLabel* userLabel = new QLabel("User:", userGroupBox_);
	QLabel* pwdLabel = new QLabel("Password:", userGroupBox_);
	QLabel* serverLabel = new QLabel("CUPS host:", userGroupBox_);
	QLabel* portLabel = new QLabel("CUPS port:", userGroupBox_);
	QLabel* configLabel = new QLabel("CUPS configuration file:", userGroupBox_);
	
	userEdit_ = new QLineEdit(userGroupBox_);
	userEdit_->setFixedHeight(userEdit_->sizeHint().height());
	userLabel->setFixedHeight(userEdit_->height());
	pwdEdit_ = new QLineEdit(userGroupBox_);
	pwdEdit_->setFixedHeight(pwdEdit_->sizeHint().height());
	pwdEdit_->setEchoMode(QLineEdit::Password);
	pwdLabel->setFixedHeight(pwdEdit_->height());
	serverEdit_ = new QLineEdit(userGroupBox_);
	serverEdit_->setFixedHeight(serverEdit_->sizeHint().height());
	serverLabel->setFixedHeight(serverEdit_->height());
	portEdit_ = new QLineEdit(userGroupBox_);
	portEdit_->setFixedHeight(portEdit_->sizeHint().height());
	portLabel->setFixedHeight(portEdit_->height());
	configEdit_ = new QLineEdit(userGroupBox_);
	configEdit_->setMinimumWidth(200);
	browseConfigButton_ = new QPushButton("Browse", userGroupBox_);
	browseConfigButton_->setFixedSize(browseConfigButton_->sizeHint());
	configEdit_->setFixedHeight(configEdit_->sizeHint().height());
	configLabel->setFixedHeight(browseConfigButton_->height());
	
	QHBoxLayout	*userLayout_ = new QHBoxLayout(userGroupBox_, 10, 5);
	QVBoxLayout	*left_ = new QVBoxLayout(0, 0, 5), *right_ = new QVBoxLayout(0, 0, 5);
	userLayout_->addLayout(left_, 1);
	userLayout_->addLayout(right_, 3);

	left_->addSpacing(5);
	left_->addWidget(userLabel);
	left_->addWidget(pwdLabel);
	left_->addWidget(serverLabel);
	left_->addWidget(portLabel);
	left_->addWidget(configLabel);

	right_->addSpacing(5);
	right_->addWidget(userEdit_);
	right_->addWidget(pwdEdit_);
	right_->addWidget(serverEdit_);
	right_->addWidget(portEdit_);
	QHBoxLayout	*sub1_ = new QHBoxLayout(0, 0, 10);
	right_->addLayout(sub1_);
	sub1_->addWidget(configEdit_, 1);
	sub1_->addWidget(browseConfigButton_);

/*	userLayout_ = new QGridLayout(userGroupBox_, 9, 5);
	userLayout_->setColStretch(0, 0);
	userLayout_->setColStretch(1, 1);
	userLayout_->setColStretch(2, 0);
	userLayout_->setColStretch(3, 3);
	userLayout_->setColStretch(4, 0);
	
	userLayout_->addColSpacing(0, 5);
	userLayout_->addColSpacing(2, 5);
	userLayout_->addColSpacing(4, 5);
	
	userLayout_->addRowSpacing(0, 5);
	userLayout_->addRowSpacing(2, 5);
	userLayout_->addRowSpacing(4, 5);
	userLayout_->addRowSpacing(6, 5);
	userLayout_->addRowSpacing(8, 5);
	
	userLayout_->setRowStretch(0, 2);
	userLayout_->setRowStretch(1, 0);
	userLayout_->setRowStretch(2, 1);
	userLayout_->setRowStretch(3, 0);
	userLayout_->setRowStretch(4, 1);
	userLayout_->setRowStretch(5, 0);
	userLayout_->setRowStretch(6, 1);
	userLayout_->setRowStretch(7, 0);
	userLayout_->setRowStretch(8, 2);
	
	userLayout_->addWidget(userLabel,   1, 1);
	userLayout_->addWidget(pwdLabel,    3, 1);
	userLayout_->addWidget(serverLabel, 5, 1);
	userLayout_->addWidget(portLabel,   7, 1);
	
	userLayout_->addWidget(userEdit_,   1, 3);
	userLayout_->addWidget(pwdEdit_,    3, 3);
	userLayout_->addWidget(serverEdit_, 5, 3);
	userLayout_->addWidget(portEdit_,   7, 3);*/
	
	

	QGroupBox* box = new QGroupBox(this);
	box->setTitle("Printers refresh interval");
	refreshTimeSlider_ = new QSlider(1, 10, 1, 2, QSlider::Horizontal, box);
	refreshTimeSlider_->setTickmarks(QSlider::Below);
	refreshTimeSlider_->setMinimumSize(refreshTimeSlider_->sizeHint());
	refreshTimeSlider_->setMaximumSize(32767, refreshTimeSlider_->sizeHint().height());
	refreshTimeLcd_ = new QLCDNumber(box);
	refreshTimeLcd_->setNumDigits(2);
	refreshTimeLcd_->setMode(QLCDNumber::DEC);
	refreshTimeLcd_->setSegmentStyle(QLCDNumber::Filled);

	mainLayout_->addWidget(box);
	QVBoxLayout	*sub_ = new QVBoxLayout(box, 10, 0);
	QHBoxLayout	*refLayout_ = new QHBoxLayout(0, 0, 10);
	sub_->addSpacing(10);
	sub_->addLayout(refLayout_);
	refLayout_->addWidget(refreshTimeSlider_);
	refLayout_->addWidget(refreshTimeLcd_);

/*	QGridLayout	*refLayout_ = new QGridLayout(box, 3, 5);
	//mainLayout_->addLayout(refLayout_);
	mainLayout_->addWidget(box);
	
	refLayout_->addWidget(refreshTimeSlider_, 1, 1);
	refLayout_->addWidget(refreshTimeLcd_, 1, 3);
	
	refLayout_->addRowSpacing(0, 15);
	refLayout_->addRowSpacing(1, 5);
	refLayout_->addRowSpacing(2, 15);
	
	refLayout_->setColStretch(0, 0);
	refLayout_->setColStretch(1, 8);
	refLayout_->setColStretch(2, 0);
	refLayout_->setColStretch(3, 1);
	refLayout_->setColStretch(4, 0);
	
	refLayout_->addColSpacing(0, 5);
	refLayout_->addColSpacing(2, 5);
	refLayout_->addColSpacing(4, 5);*/
	
	
	
/*	testPageLayout_ = new QGridLayout(3, 7);
	mainLayout_->addLayout(testPageLayout_);*/
	
	QLabel* testPageLabel = new QLabel("Test page", this);
	testPageLabel->setFixedSize(testPageLabel->sizeHint());
	testPageEdit_ = new QLineEdit(this);
	testPageEdit_->setFixedHeight(testPageEdit_->sizeHint().height());
	browseButton_ = new QPushButton("Browse", this);
	browseButton_->setFixedSize(browseButton_->sizeHint());
	
	QHBoxLayout	*testPageLayout_ = new QHBoxLayout(0, 0, 10);
	mainLayout_->addLayout(testPageLayout_);
	testPageLayout_->addWidget(testPageLabel);
	testPageLayout_->addWidget(testPageEdit_, 1);
	testPageLayout_->addWidget(browseButton_);

/*	testPageLayout_->addWidget(testPageLabel, 1, 1);
	testPageLayout_->addWidget(testPageEdit_, 1, 3);
	testPageLayout_->addWidget(browseButton_, 1, 5);

	testPageLayout_->addColSpacing(0, 5);
	testPageLayout_->addColSpacing(2, 5);
	testPageLayout_->addColSpacing(4, 5);
	testPageLayout_->addColSpacing(6, 5);
	
	testPageLayout_->setColStretch(0, 0);
	testPageLayout_->setColStretch(1, 2);
	testPageLayout_->setColStretch(2, 0);
	testPageLayout_->setColStretch(3, 5);
	testPageLayout_->setColStretch(4, 0);
	testPageLayout_->setColStretch(5, 2);
	testPageLayout_->setColStretch(6, 0);*/
	
//	buttonsLayout_ = new QGridLayout(3, 5);
//	mainLayout_->addLayout(buttonsLayout_);
	
	okButton_ = new QPushButton("Ok", this);
	okButton_->setFixedSize(okButton_->sizeHint());
	cancelButton_ = new QPushButton("Cancel", this);
	cancelButton_->setFixedSize(cancelButton_->sizeHint());

	QHBoxLayout	*buttonsLayout_ = new QHBoxLayout(0, 0, 10);
	mainLayout_->addSpacing(10);
	mainLayout_->addLayout(buttonsLayout_);
	buttonsLayout_->addStretch(1);
	buttonsLayout_->addWidget(okButton_);
	buttonsLayout_->addWidget(cancelButton_);

/*	buttonsLayout_->addWidget(okButton_, 1, 1);
	buttonsLayout_->addWidget(cancelButton_, 1, 3);
	
	buttonsLayout_->addRowSpacing(0, 5);
	buttonsLayout_->addRowSpacing(2, 5);
	
	buttonsLayout_->setRowStretch(0, 1);
	buttonsLayout_->setRowStretch(1, 3);
	buttonsLayout_->setRowStretch(2, 1);
	
	buttonsLayout_->addColSpacing(0, 20);
	buttonsLayout_->addColSpacing(2, 20);
	buttonsLayout_->addColSpacing(4, 20);
	
	buttonsLayout_->setColStretch(0, 20);
	buttonsLayout_->setColStretch(1, 1);
	buttonsLayout_->setColStretch(2, 1);
	buttonsLayout_->setColStretch(3, 1);
	buttonsLayout_->setColStretch(4, 1);*/
	
//	mainLayout_->activate();
	
//	resize(500, 300);
	
	makeConnections();
	
	initWidgets();
}
Kups_OptionsDialog::~Kups_OptionsDialog()
{
}
	
void Kups_OptionsDialog::initWidgets()
{
	QString str;
	infos_ = Kups_Infos::get();
	
	userEdit_->setText( infos_->getUser() );
	pwdEdit_->setText( infos_->getPassword() );
	serverEdit_->setText( infos_->getServer() );
	str.setNum(infos_->getPort());
	portEdit_->setText(str);
	configEdit_->setText( infos_->getConfigFile() );
	
	refreshTimeSlider_->setValue( infos_->getRefreshTime() );
	refreshTimeLcd_->display(infos_->getRefreshTime());
	
	testPageEdit_->setText( infos_->getTestPage() );
}

void Kups_OptionsDialog::makeConnections()
{
	connect(userEdit_, SIGNAL(returnPressed()), this, SLOT(slotUserEdit()) );
	connect(pwdEdit_, SIGNAL(returnPressed()), this, SLOT(slotPwdEdit()) );
	connect(serverEdit_, SIGNAL(returnPressed()), this, SLOT(slotServerEdit()) );
	connect(portEdit_, SIGNAL(returnPressed()), this, SLOT(slotPortEdit()) );
	
	connect(refreshTimeSlider_, SIGNAL(valueChanged(int)), this, SLOT(slotRefreshSlider(int)) );
	
	connect(testPageEdit_, SIGNAL(returnPressed()), this, SLOT(slotTestPageEdit()) );
	connect(browseButton_, SIGNAL(clicked()), this, SLOT(slotBrowseButton()) );
	connect(browseConfigButton_, SIGNAL(clicked()), this, SLOT(slotBrowseConfigButton()) );
	
	connect(okButton_, SIGNAL(clicked()), this, SLOT(slotOkButton()) );
	connect(cancelButton_, SIGNAL(clicked()), this, SLOT(slotCancelButton()) );
}

void Kups_OptionsDialog::slotUserEdit()
{
}
void Kups_OptionsDialog::slotPwdEdit()
{
}
void Kups_OptionsDialog::slotServerEdit()
{
}
void Kups_OptionsDialog::slotPortEdit()
{
}
	
void Kups_OptionsDialog::slotRefreshSlider(int index)
{
	refreshTimeLcd_->display( index );
}
	
void Kups_OptionsDialog::slotTestPageEdit()
{
}
void Kups_OptionsDialog::slotBrowseButton()
{
	QFileInfo info( testPageEdit_->text() );
	QString str = KFileDialog::getOpenFileName(info.dirPath(true), "*.ps", this);
	if (!str.isEmpty())
	{
		testPageEdit_->setText(str);
	}
}

void Kups_OptionsDialog::slotBrowseConfigButton()
{
	QFileInfo info( configEdit_->text() );
	QString str = KFileDialog::getOpenFileName(info.dirPath(true), QString::null, this);
	if (!str.isEmpty())
	{
		configEdit_->setText(str);
	}
}

void Kups_OptionsDialog::slotOkButton()
{
	QString str;
	
	infos_->setUser( userEdit_->text() );
	infos_->setPassword( pwdEdit_->text() );
	infos_->setServer( serverEdit_->text() );
	str = portEdit_->text();
	infos_->setPort( str.toInt() );
	infos_->setConfigFile( configEdit_->text() );
	
	infos_->setRefreshTime( refreshTimeSlider_->value() );
	
	infos_->setTestPage( testPageEdit_->text() );
	
	done(1);
}
void Kups_OptionsDialog::slotCancelButton()
{
	done(0);
}
