#ifndef KUPS_PRINTERPROPVIEW_H
#define	KUPS_PRINTERPROPVIEW_H

#include <qwidget.h>
#include <qlabel.h>
#include <qstrlist.h>

#include "kprinterdescription.h"

class KPrinter;
class QListViewItem;
class QGroupBox;
class QPushButton;
class QTextView;

class Kups_PrinterPropView : public QWidget
{
	Q_OBJECT
public:
	Kups_PrinterPropView(QWidget *parent = 0, const char *name = 0);
	~Kups_PrinterPropView();

	void setPrinter(KPrinter *printer);

protected:
	void createWidget();
	void setupForPrinter(bool on);	// if on == false -> class
	void updatePrinter(KPrinterDescription*);

protected slots:
	void slotGeneralChange();
	void slotBackendChange();
	void slotDriverChange();
	void slotMembersChange();
	void slotBannerChange();
	void slotPrinterSelected(QListViewItem*);

private:
	KPrinter	*printer_;
        QStrList	membersList_;

	QLabel		*nameLabel_, *descLabel_, *locLabel_;
	QLabel		*typeLabel_, *uriLabel_;
	QLabel		*manuLabel_, *modelLabel_, *nickLabel_;
	QTextView	*membersView_;
	QLabel		*startLabel_, *endLabel_;

	QGroupBox	*genbox_, *backendbox_, *driverbox_, *membersbox_, *bannerbox_;
	QPushButton	*genchange_, *backendchange_, *driverchange_, *memberschange_, *bannerchange_;
};

class ToolLabel : public QLabel
{
	Q_OBJECT
public:
	ToolLabel(QWidget *parent = 0, const char *name = 0);
        ~ToolLabel();
public slots:
	virtual void setText(const QString&);
protected:
	void resizeEvent(QResizeEvent*);
	void checkTip();
};

#endif
