/***************************************************************************
                          optionsdirspage.cpp  -  description
                             -------------------
    begin                : Thu Jan 4 2001
    copyright            : (C) 2001 by Michael Goffioul
    email                : goffioul@imec.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "optionsdirspage.h"

#include <kfiledialog.h>
#include <qlineedit.h>

OptionsDirsPage::OptionsDirsPage(QWidget *parent, const char *name ) : OptionsDirsPageBase(parent,name) {
}
OptionsDirsPage::~OptionsDirsPage(){
}

void OptionsDirsPage::slotBrowseDrivers()
{
	QString	dirname = KFileDialog::getExistingDirectory(driversedit_->text(), this);
	if (!dirname.isEmpty())
	{
		driversedit_->setText(dirname);
	}
}

void OptionsDirsPage::slotBrowseConfig()
{
	QString	filename = KFileDialog::getOpenFileName(configedit_->text(), "*.conf|Configuration files (*.conf)\n*|All files", this);
	if (!filename.isEmpty())
	{
		configedit_->setText(filename);
	}
}

void OptionsDirsPage::slotBrowseRoot()
{
	QString	dirname = KFileDialog::getExistingDirectory(rootedit_->text(), this);
	if (!dirname.isEmpty())
	{
		rootedit_->setText(dirname);
	}
}

void OptionsDirsPage::slotRootChanged(const QString& str)
{
	QString	root = rootedit_->text();
	if (!root.isEmpty())
	{
		if (root[root.length()-1] != '/') root.append("/");
		driversedit_->setText(root + "share/cups/model/");
		configedit_->setText(root + "etc/cups/cupsd.conf");
	}
}
