/***************************************************************************
                          optionstestpage.cpp  -  description
                             -------------------
    begin                : Thu Jan 4 2001
    copyright            : (C) 2001 by Michael Goffioul
    email                : goffioul@imec.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "optionstestpage.h"

#include <kfiledialog.h>
#include <klocale.h>
#include <krun.h>
#include <kmimemagic.h>
#include <qlineedit.h>
#include <qmessagebox.h>

#include <cups/cups.h>

#include "kups_testpagegenerator.h"
#include "kbuffer.h"
#include "kups_infos.h"

OptionsTestPage::OptionsTestPage(QWidget *parent, const char *name ) : OptionsTestPageBase(parent,name) {
}
OptionsTestPage::~OptionsTestPage(){
	QStringList::Iterator	it;
	for (it=tmpfiles_.begin(); it!=tmpfiles_.end();++it)
		unlink((*it).data());
}

void OptionsTestPage::slotBrowseTestPage()
{
	QString	filename = KFileDialog::getOpenFileName(testpage_->text(), "*.ps|PostScript document (*.ps)", this);
	if (!filename.isEmpty())
	{
		testpage_->setText(filename);
	}
}

void OptionsTestPage::slotPreviewTestPage()
{
	if (testpage_->text().isEmpty()) return;

	QString	oldtestpage = Kups_Infos::get()->getTestPage();
	Kups_Infos::get()->setTestPage(testpage_->text());

	KBuffer	buf = Kups_TestPageGenerator::getPage(0);
	QString	tmpfile = cupsTempFile(NULL, 0);
	tmpfiles_.append(tmpfile);
	if (!buf.dump(tmpfile))
	{
		QMessageBox::critical(this, i18n("Error"), i18n("Unable to generate temporary file"), QMessageBox::Ok|QMessageBox::Default, 0);
	}
	else
	{
		KRun::runURL(tmpfile, KMimeMagic::self()->findFileType(tmpfile)->mimeType());
	}

	Kups_Infos::get()->setTestPage(oldtestpage);
}
