#include "qdirlineedit.h"

#include <qlineedit.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <kfiledialog.h>

QDirLineEdit::QDirLineEdit(QWidget *parent, const char *name)
	: QWidget(parent, name)
{
	edit_ = new QLineEdit(this);
	button_ = new QPushButton("Browse...", this);
	connect(button_,SIGNAL(clicked()),SLOT(buttonClicked()));

	QHBoxLayout	*main_ = new QHBoxLayout(this, 0, 10);
	main_->addWidget(edit_);
	main_->addWidget(button_);

	fileedit_ = false;
}

QDirLineEdit::~QDirLineEdit()
{
}

void QDirLineEdit::setText(const QString& txt)
{
	edit_->setText(txt);
}

void QDirLineEdit::setButtonText(const QString& txt)
{
	button_->setText(txt);
}

QString QDirLineEdit::text()
{
	return edit_->text();
}

QSize QDirLineEdit::sizeHint() const
{
	QSize	s1(edit_->sizeHint()), s2(button_->sizeHint());
	return QSize(s1.width()+s2.width()+10,s1.height());
}

void QDirLineEdit::buttonClicked()
{
	QString	dirname;
	if (!fileedit_) dirname = KFileDialog::getExistingDirectory(edit_->text(), this);
	else dirname = KFileDialog::getOpenFileName(edit_->text(), QString::null, this);
	if (!dirname.isEmpty()) edit_->setText(dirname);
}

void QDirLineEdit::setFileEdit(bool on)
{
	fileedit_ = on;
}
